﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;

namespace Demo05
{
	[ExternalDataExchange]
    interface IMyDocumentEvents
	{
        event EventHandler<ExternalDataEventArgs> Fixed;
        event EventHandler<ExternalDataEventArgs> ByDesign;
        event EventHandler<ExternalDataEventArgs> Deferred;
        event EventHandler<ExternalDataEventArgs> Duplicate;

        event EventHandler<ExternalDataEventArgs> ResolutionDenied;
        event EventHandler<ExternalDataEventArgs> WrongFix;
        event EventHandler<ExternalDataEventArgs> TestFailed;

        event EventHandler<ExternalDataEventArgs> Regression;
        event EventHandler<ExternalDataEventArgs> Reactivated;

        event EventHandler<ExternalDataEventArgs> Obsolete;
        event EventHandler<ExternalDataEventArgs> UnableToReproduce;
        
        event EventHandler<ExternalDataEventArgs> Archive;

    }
    [Serializable]
    class DocumentMetadata : IMyDocumentEvents
    {
        public void FireFixed(Guid instanceId)
        {
            ExternalDataEventArgs args = new ExternalDataEventArgs(instanceId);
            Fixed(this, args);
        }

        public void FireArchive(Guid instanceId)
        {
            ExternalDataEventArgs args = new ExternalDataEventArgs(instanceId);
            Archive(this, args);
        }

        public event EventHandler<ExternalDataEventArgs> Fixed;
        public event EventHandler<ExternalDataEventArgs> ByDesign;
        public event EventHandler<ExternalDataEventArgs> Deferred;
        public event EventHandler<ExternalDataEventArgs> Duplicate;

        public event EventHandler<ExternalDataEventArgs> ResolutionDenied;
        public event EventHandler<ExternalDataEventArgs> WrongFix;
        public event EventHandler<ExternalDataEventArgs> TestFailed;

        public event EventHandler<ExternalDataEventArgs> Regression;
        public event EventHandler<ExternalDataEventArgs> Reactivated;

        public event EventHandler<ExternalDataEventArgs> Obsolete;
        public event EventHandler<ExternalDataEventArgs> UnableToReproduce;

        public event EventHandler<ExternalDataEventArgs> Archive;

    }
}
